/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class ServletImpl extends DefaultHandler implements Cloneable, Unmarshallable, LexicalHandler, Servlet {

    private Icon icon;
    private ServletName servletName;
    private DisplayName displayName;
    private Description description;
    private ServletClass servletClass;
    private JspFile jspFile;
    private List initParamList;
    private LoadOnStartup loadOnStartup;
    private RunAs runAs;
    private List securityRoleRefList;
    private String id;
    private boolean zeus_IdSet;

    /** Any DOCTYPE reference/statements. */
    private String docTypeString;

    /** The encoding for the output document */
    private String outputEncoding;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** Whether a DTD exists for an unmarshal call */
    private boolean hasDTD;

    /** Whether validation is occurring */
    private boolean validate;

    /** The namespace mappings on this element */
    private Map namespaceMappings;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    private static ServletImpl prototype = null;

    public static void setPrototype(ServletImpl prototype) {
        ServletImpl.prototype = prototype;
    }
    public static ServletImpl newInstance() {
        try {
            return (prototype!=null)?(ServletImpl)prototype.clone(): new ServletImpl();
        } catch (CloneNotSupportedException e) {
            return null; // never
        }
    }
    public ServletImpl() {
        initParamList = new LinkedList();
        securityRoleRefList = new LinkedList();
        zeus_IdSet = false;
        docTypeString = "";
        hasDTD = false;
        validate = false;
        namespaceMappings = new HashMap();
    }

    public Icon getIcon() {
        return icon;
    }

    public void setIcon(Icon icon) {
        this.icon = icon;
    }

    public ServletName getServletName() {
        return servletName;
    }

    public void setServletName(ServletName servletName) {
        this.servletName = servletName;
    }

    public DisplayName getDisplayName() {
        return displayName;
    }

    public void setDisplayName(DisplayName displayName) {
        this.displayName = displayName;
    }

    public Description getDescription() {
        return description;
    }

    public void setDescription(Description description) {
        this.description = description;
    }

    public ServletClass getServletClass() {
        return servletClass;
    }

    public void setServletClass(ServletClass servletClass) {
        this.servletClass = servletClass;
    }

    public JspFile getJspFile() {
        return jspFile;
    }

    public void setJspFile(JspFile jspFile) {
        this.jspFile = jspFile;
    }

    public List getInitParamList() {
        return initParamList;
    }

    public void setInitParamList(List initParamList) {
        this.initParamList = initParamList;
    }

    public void addInitParam(InitParam initParam) {
        initParamList.add(initParam);
    }

    public void removeInitParam(InitParam initParam) {
        initParamList.remove(initParam);
    }

    public LoadOnStartup getLoadOnStartup() {
        return loadOnStartup;
    }

    public void setLoadOnStartup(LoadOnStartup loadOnStartup) {
        this.loadOnStartup = loadOnStartup;
    }

    public RunAs getRunAs() {
        return runAs;
    }

    public void setRunAs(RunAs runAs) {
        this.runAs = runAs;
    }

    public List getSecurityRoleRefList() {
        return securityRoleRefList;
    }

    public void setSecurityRoleRefList(List securityRoleRefList) {
        this.securityRoleRefList = securityRoleRefList;
    }

    public void addSecurityRoleRef(SecurityRoleRef securityRoleRef) {
        securityRoleRefList.add(securityRoleRef);
    }

    public void removeSecurityRoleRef(SecurityRoleRef securityRoleRef) {
        securityRoleRefList.remove(securityRoleRef);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
        zeus_IdSet = true;
    }

    public void setDocType(String name, String publicID, String systemID) {
        try {
            startDTD(name, publicID, systemID);
        } catch (SAXException neverHappens) { }
    }

    public void setOutputEncoding(String outputEncoding) {
        this.outputEncoding = outputEncoding;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" ");
        if (outputEncoding != null) {
            writer.write("encoding=\"");
            writer.write(outputEncoding);
            writer.write("\"?>\n\n");

        } else {
            writer.write("encoding=\"UTF-8\"?>\n\n");

        }
        // Handle DOCTYPE declaration
        writer.write(docTypeString);
        writer.write("\n");
        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<servlet");

        // Handle namespace mappings (if needed)
        for (Iterator i = namespaceMappings.keySet().iterator(); i.hasNext(); ) {
            String prefix = (String)i.next();
            String uri = (String)namespaceMappings.get(prefix);
            writer.write(" xmlns");
            if (!prefix.trim().equals("")) {
                writer.write(":");
                writer.write(prefix);
            }
            writer.write("=\"");
            writer.write(uri);
            writer.write("\"\n        ");
        }

        // Handle attributes (if needed)
        if (zeus_IdSet) {
            writer.write(" id=\"");
            writer.write(escapeAttributeValue(id));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (icon != null) {
            ((IconImpl)icon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (servletName != null) {
            ((ServletNameImpl)servletName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (displayName != null) {
            ((DisplayNameImpl)displayName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (description != null) {
            ((DescriptionImpl)description).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (servletClass != null) {
            ((ServletClassImpl)servletClass).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (jspFile != null) {
            ((JspFileImpl)jspFile).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=initParamList.iterator(); i.hasNext(); ) {
            InitParamImpl initParam = (InitParamImpl)i.next();
            initParam.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (loadOnStartup != null) {
            ((LoadOnStartupImpl)loadOnStartup).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (runAs != null) {
            ((RunAsImpl)runAs).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=securityRoleRefList.iterator(); i.hasNext(); ) {
            SecurityRoleRefImpl securityRoleRef = (SecurityRoleRefImpl)i.next();
            securityRoleRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        writer.write(indent);
        writer.write("</servlet>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    private String escapeTextValue(String textValue) {
        String returnValue = textValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '<') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&lt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            } else if (ch == '>') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&gt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static Servlet unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Servlet unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Servlet unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Servlet unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Servlet unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Servlet unmarshal(Reader reader, boolean validate) throws IOException {
        ServletImpl servlet = ServletImpl.newInstance();
        servlet.setValidating(validate);
        servlet.setCurrentUNode(servlet);
        servlet.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler
            parser.setErrorHandler(servlet);

            // Register lexical handler
            parser.setProperty("http://xml.org/sax/properties/lexical-handler", servlet);

            // Register content handler
            parser.setContentHandler(servlet);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.setFeature("http://xml.org/sax/features/namespaces", true);
            parser.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return servlet;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void setValidating(boolean validate) {
        this.validate = validate;
    }

    public void startDocument() throws SAXException {
        // no-op
    }

    public void setDocumentLocator(Locator locator) {
        // no-op
    }

    public void startPrefixMapping(String prefix, String uri)
        throws SAXException {
        namespaceMappings.put(prefix, uri);
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, org.xml.sax.Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("servlet")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("id")) {
                    setId(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("icon") && (icon==null)) {
                IconImpl icon = IconImpl.newInstance();
                current = getCurrentUNode();
                icon.setParentUNode(current);
                icon.setCurrentUNode(icon);
                this.setCurrentUNode(icon);
                icon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.icon = icon;
                return;
            }
            if (localName.equals("servlet-name") && (servletName==null)) {
                ServletNameImpl servletName = ServletNameImpl.newInstance();
                current = getCurrentUNode();
                servletName.setParentUNode(current);
                servletName.setCurrentUNode(servletName);
                this.setCurrentUNode(servletName);
                servletName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.servletName = servletName;
                return;
            }
            if (localName.equals("display-name") && (displayName==null)) {
                DisplayNameImpl displayName = DisplayNameImpl.newInstance();
                current = getCurrentUNode();
                displayName.setParentUNode(current);
                displayName.setCurrentUNode(displayName);
                this.setCurrentUNode(displayName);
                displayName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.displayName = displayName;
                return;
            }
            if (localName.equals("description") && (description==null)) {
                DescriptionImpl description = DescriptionImpl.newInstance();
                current = getCurrentUNode();
                description.setParentUNode(current);
                description.setCurrentUNode(description);
                this.setCurrentUNode(description);
                description.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.description = description;
                return;
            }
            if (localName.equals("servlet-class") && (servletClass==null)) {
                ServletClassImpl servletClass = ServletClassImpl.newInstance();
                current = getCurrentUNode();
                servletClass.setParentUNode(current);
                servletClass.setCurrentUNode(servletClass);
                this.setCurrentUNode(servletClass);
                servletClass.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.servletClass = servletClass;
                return;
            }
            if (localName.equals("jsp-file") && (jspFile==null)) {
                JspFileImpl jspFile = JspFileImpl.newInstance();
                current = getCurrentUNode();
                jspFile.setParentUNode(current);
                jspFile.setCurrentUNode(jspFile);
                this.setCurrentUNode(jspFile);
                jspFile.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.jspFile = jspFile;
                return;
            }
            if (localName.equals("init-param")) {
                InitParamImpl initParam = InitParamImpl.newInstance();
                current = getCurrentUNode();
                initParam.setParentUNode(current);
                initParam.setCurrentUNode(initParam);
                this.setCurrentUNode(initParam);
                initParam.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                initParamList.add(initParam);
                return;
            }
            if (localName.equals("load-on-startup") && (loadOnStartup==null)) {
                LoadOnStartupImpl loadOnStartup = LoadOnStartupImpl.newInstance();
                current = getCurrentUNode();
                loadOnStartup.setParentUNode(current);
                loadOnStartup.setCurrentUNode(loadOnStartup);
                this.setCurrentUNode(loadOnStartup);
                loadOnStartup.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.loadOnStartup = loadOnStartup;
                return;
            }
            if (localName.equals("run-as") && (runAs==null)) {
                RunAsImpl runAs = RunAsImpl.newInstance();
                current = getCurrentUNode();
                runAs.setParentUNode(current);
                runAs.setCurrentUNode(runAs);
                this.setCurrentUNode(runAs);
                runAs.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.runAs = runAs;
                return;
            }
            if (localName.equals("security-role-ref")) {
                SecurityRoleRefImpl securityRoleRef = SecurityRoleRefImpl.newInstance();
                current = getCurrentUNode();
                securityRoleRef.setParentUNode(current);
                securityRoleRef.setCurrentUNode(securityRoleRef);
                this.setCurrentUNode(securityRoleRef);
                securityRoleRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                securityRoleRefList.add(securityRoleRef);
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

    public void comment(char ch[], int start, int len) throws SAXException {
        // Currently no-op
    }

    public void warning(SAXParseException e) throws SAXException {
        if (errorHandler != null) {
            errorHandler.warning(e);
        }
    }

    public void error(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.error(e);
        }
    }

    public void fatalError(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.fatalError(e);
        }
    }

    public void startDTD(String name, String publicID, String systemID)
        throws SAXException {

        if ((name == null) || (name.equals(""))) {
            docTypeString = "";
            return;
        }

        hasDTD = true;
        StringBuffer docTypeSB = new StringBuffer();
        boolean hasPublic = false;

        docTypeSB.append("<!DOCTYPE ")
                 .append(name);

        if ((publicID != null) && (!publicID.equals(""))) {
            docTypeSB.append(" PUBLIC \"")
                     .append(publicID)
                     .append("\"");
            hasPublic = true;
        }

        if ((systemID != null) && (!systemID.equals(""))) {
            if (!hasPublic) {
                docTypeSB.append(" SYSTEM");
            }
            docTypeSB.append(" \"")
                     .append(systemID)
                     .append("\"");

        }

        docTypeSB.append(">");

        docTypeString = docTypeSB.toString();
    }

    public void endDTD() throws SAXException {
        // Currently no-op
    }

    public void startEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void endEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void startCDATA() throws SAXException {
        // Currently no-op
    }

    public void endCDATA() throws SAXException {
        // Currently no-op
    }

}
